/**
 * Visualization of the Sutherland-Hodgman-Algorithm for clipping polygons
 * against a rectangle.
 *
 * Author : Sunshine
 * WEB : www.sunshine2k.de
 *
 * Questions, comments, critics? -> webmaster(at)sunshine2k(dot)de
 * November 2007
 */

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;


public class SutherlandHodgmanApplet extends javax.swing.JApplet {
    
    private DrawPanel panel;
    
    /** Initializes the applet SutherlandHodgmanApplet */
    public void init() {
        try {
            java.awt.EventQueue.invokeAndWait(new Runnable() {
                public void run() {
                    initComponents();
                }
            });
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        
        setSize(600, 450);
        panel = new DrawPanel(this);
        this.add(panel);
        panel.setVisible(true);
        
        // react on clip polygon button
        this.ClipPolyButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                panel.clip();
            }
        });
        
        this.StepByStepBox.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                panel.stepMode = (e.getStateChange() == ItemEvent.SELECTED);
            }    
        });
        
        this.ResetButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                panel.reset();
            }
        });

    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        ClipPolyButton = new javax.swing.JButton();
        StepByStepBox = new javax.swing.JCheckBox();
        ResetButton = new javax.swing.JButton();

        ClipPolyButton.setText("Clip Polygon");

        StepByStepBox.setText("'Step by Step' Mode");
        StepByStepBox.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        StepByStepBox.setMargin(new java.awt.Insets(0, 0, 0, 0));

        ResetButton.setText("Reset");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(18, 18, 18)
                .addComponent(ClipPolyButton, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(25, 25, 25)
                .addComponent(StepByStepBox)
                .addGap(23, 23, 23)
                .addComponent(ResetButton, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(178, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(372, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ClipPolyButton)
                    .addComponent(StepByStepBox)
                    .addComponent(ResetButton))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton ClipPolyButton;
    private javax.swing.JButton ResetButton;
    private javax.swing.JCheckBox StepByStepBox;
    // End of variables declaration//GEN-END:variables
    
}
